//
//  DLMovieCell.m
//  MoviePad
//
//  Created by Donald Livanec on 6/1/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DLMovieCell.h"
#import "DLMovie.h"

@implementation DLMovieCell
@synthesize bgImage;
@synthesize title;
@synthesize thumnNail;
@synthesize movieTitle;
@synthesize movieData;
@synthesize criticLabel;
@synthesize audienceLabel;
@synthesize criticImg;
@synthesize audienceImg;
@synthesize criticCountImg;
@synthesize criticCountLbl;
@synthesize audienceCountImg;
@synthesize audienceCountLbl;

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        // Initialization code
        [title setText:[movieData title]];
        //[title setText:[movieData set];
    }
    return self;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{    
    if (selected)
    {        
        [bgImage setImage:[UIImage imageNamed:@"menu-selected.png"]];
        [criticCountImg setImage:[UIImage imageNamed:@"count-selected"]];
        [audienceCountImg setImage:[UIImage imageNamed:@"count-selected"]];
        [criticCountLbl setTextColor:[UIColor grayColor]];
        [audienceCountLbl setTextColor:[UIColor grayColor]];
        [title setTextColor:[UIColor whiteColor]];    
    } 
    else{
        [bgImage setImage:[UIImage imageNamed:@"menu.png"]];
        [criticCountImg setImage:[UIImage imageNamed:@"count"]];
        [audienceCountImg setImage:[UIImage imageNamed:@"count"]];
        [criticCountLbl setTextColor:[UIColor whiteColor]];
        [audienceCountLbl setTextColor:[UIColor whiteColor]];
        [title setTextColor:[UIColor darkGrayColor]];
    }
    
     [super setSelected:selected animated:animated];  
          
}
- (void *)applyMovieValues
{
    [title setText:[movieData title]];
    [thumnNail loadHTMLString:[[NSString alloc] initWithFormat:@"<img src='%@'/>", [movieData thumbnail]] baseURL:nil];  
    NSString *criticScore = [[NSString alloc] initWithFormat: @"%@%@",[[movieData critics_score] stringValue], @"%"]; 
    NSString *audienceScore = [[NSString alloc] initWithFormat: @"%@%@",[[movieData audience_score] stringValue], @"%"];
    [criticCountLbl setText:criticScore];   
    [audienceCountLbl setText:audienceScore];

    if ( [[movieData critics_score] intValue] < 50 ){
        [criticImg setImage:[UIImage imageNamed:@"critics-dislike.png"]];
    }
    if ( [[movieData audience_score] intValue] < 50 ){
        [audienceImg setImage:[UIImage imageNamed:@"audience-dislike.png"]];
    }
    
}
@end
