//
//  DLViewController.m
//  MoviePad
//
//  Created by Donald Livanec on 5/30/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//
#define bgQueue dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0) //1
#define rTomatoesURL [NSURL URLWithString: @"http://api.rottentomatoes.com/api/public/v1.0/lists/movies/box_office.json?limit=16&country=us&apikey=3atvjjwrmajgxybkxhqjh4pt"]

#import "DLViewController.h"
#import "DLMovie.h"
#import "DLMovieCell.h"

@interface DLViewController ()
@property (nonatomic, strong) NSMutableArray *data;
@end

@implementation DLViewController
@synthesize movieInfo;
@synthesize webImage;
@synthesize movieDetails, movieTable;
@synthesize data = _data;

- (void)viewDidLoad
{
    [super viewDidLoad];
	dispatch_async(bgQueue, ^{
        NSData* remotedata = [NSData dataWithContentsOfURL:rTomatoesURL];
        [self performSelectorOnMainThread:@selector(fetchedData:) 
                               withObject:remotedata waitUntilDone:YES];
    });
    [webImage setOpaque:NO];
    [webImage setBackgroundColor:[UIColor clearColor]];
    [[webImage scrollView] setScrollEnabled:NO];
    [[webImage scrollView] setBounces:NO];
    [movieInfo setOpaque:NO];
    [movieInfo setBackgroundColor:[UIColor clearColor]];
    [[movieInfo scrollView] setScrollEnabled:NO];
    [[movieInfo scrollView] setBounces:NO];

}

- (void)fetchedData:(NSData *)responseData {
    //parse out the json data
    NSError* error;
    NSDictionary* json = [NSJSONSerialization JSONObjectWithData:responseData options:kNilOptions error:&error]; 
    
    NSArray* boxOfficeMoviesData = [json objectForKey:@"movies"];   
    NSMutableArray *data = [NSMutableArray array];
    
    for (int i = 0; i < [boxOfficeMoviesData count]; i++){        
        DLMovie *movie = [[DLMovie alloc] init];
        [movie setTitle:[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"title"]];
        [movie setYear:[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"year"]];
        [movie setMpaa_rating:[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"mpaa_rating"]];        
        [movie setRuntime:[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"runtime"]];
        [movie setCritics_consensus:[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"critics_consensus"]];        
        [movie setRelease_date:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"release_dates"]objectForKey:@"theater"]];
        [movie setCritics_rating:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"ratings"]objectForKey:@"critics_rating"]];        
        [movie setCritics_score:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"ratings"] objectForKey:@"critics_score"]];        
        [movie setAudience_score:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"ratings"]objectForKey:@"audience_score"]];
        [movie setAudience_rating:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"ratings"]objectForKey:@"audience_rating"]];        
        [movie setSynopsis:[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"synopsis"]];
        [movie setThumbnail:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"posters"]objectForKey:@"thumbnail"]];
        [movie setProfile:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"posters"]objectForKey:@"profile"]];
        [movie setDetailed:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"posters"]objectForKey:@"detailed"]];        
        [movie setOriginal:[[[boxOfficeMoviesData objectAtIndex:i]objectForKey:@"posters"]objectForKey:@"original"]];
        [data addObject:movie];
        //NSString *foo = [[NSString alloc] initWithFormat: @"foobar"];
    }
    [self setData:data];
    [movieTable reloadData];
    DLMovie *movie = [[self data] objectAtIndex:0];
    [movieDetails setText: [movie title]];    
    [movieInfo loadHTMLString:[movie description] baseURL:nil];    
    [webImage loadHTMLString:[[NSString alloc] initWithFormat:@"<img src='%@'/>", [movie detailed]] baseURL:nil];
}

- (void)viewDidUnload
{
    [self setMovieTable:nil];
    [self setMovieInfo:nil];
    [self setWebImage:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;
}

#pragma mark - UITableViewDelegate and UITableViewDataSource Methods

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    NSInteger count = [[self data] count];
    return count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString *cellID = @"cellID";    
    DLMovieCell* cell = [tableView dequeueReusableCellWithIdentifier:cellID];

    //[tableView setRowHeight:91];
    
    if(cell == nil)
    {
        NSArray* views = [[NSBundle mainBundle] loadNibNamed:@"DLMovieCell" owner:nil options:nil];    
        
        for (id obj in views) {
            if([obj isKindOfClass:[UITableViewCell class]])
            {
                cell = (DLMovieCell*)obj;
                DLMovie *movie = [[self data] objectAtIndex:[indexPath row]];
                [cell setMovieData:movie];                
                [cell applyMovieValues];
                break;
            }
        }
    }    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    DLMovie *movie = [[self data] objectAtIndex:[indexPath row]];
    [movieDetails setText: [movie title]];
    [movieInfo loadHTMLString:[movie description] baseURL:nil];  
//    webView.opaque = NO;
//    webView.backgroundColor = [UIColor clearColor];
    [webImage loadHTMLString:[[NSString alloc] initWithFormat:@"<body style='background-color: transparent;'><img src='%@'/>", [movie detailed]] baseURL:nil];
    [webImage setOpaque:NO];
    [webImage setBackgroundColor:[UIColor clearColor]];
    [[webImage scrollView] setScrollEnabled:NO];
    [[webImage scrollView] setBounces:NO];
}

@end
